; setup our Screen Width and Height here for easier tracking
#ScreenWidth  = 640
#ScreenHeight = 480

; Initialize the sprite and keyboard, joystick, and a 640x480, 16-bit screen
If InitSprite() = 0 Or InitKeyboard() = 0 Or InitJoystick() = 0 Or OpenScreen(#ScreenWidth,#ScreenHeight,16,"App Title") = 0
   MessageRequester("Error!", "Unable to Initialize Environment", #PB_MessageRequester_Ok)
   End
EndIf

ClearColor = RGB(0,0,0) 

LastButton.s = "None"
OtherButton.s = "None"
 
; Keep going until the user hits a key
Repeat
   ; clear the screen
   ClearScreen(ClearColor)

   Button.s = ""
   If ExamineJoystick(0)
      ; check to see if there has been any movement on X
      X_Movement = JoystickAxisX(0)
      If X_Movement < 0
         X_JoystickMovement.s = "Left"
      Else   
         If X_Movement > 0
            X_JoystickMovement.s = "Right"
         Else
            X_JoystickMovement.s = ""
         EndIf
      EndIf

      ; check to see if there has been any movement on Y
      Y_Movement = JoystickAxisY(0)
      If Y_Movement < 0
         Y_JoystickMovement.s = "Up"
      Else   
         If Y_Movement > 0
            Y_JoystickMovement.s = "Down"
         Else
            Y_JoystickMovement.s = ""
         EndIf
      EndIf

      ; check to see if any of the buttons have been pressed
      For Buttons = 1 To 10
          If JoystickButton(0,Buttons)
             If Button.s = ""
                Button.s = Str(Buttons) 
             Else
                Button.s = Button.s + ", " + Str(Buttons) 
             EndIf
          EndIf
      Next

   EndIf

   ; put up text for exiting
   StartDrawing(ScreenOutput())
     DrawText(0,0,"Buttons Pressed: " + Button.s)
     DrawText(0,20,"X Movement = " + X_JoystickMovement.s )
     DrawText(0,40,"Y Movement = " + Y_JoystickMovement.s )
     DrawText(0,460,"Press any key To quit")
   StopDrawing()

   FlipBuffers()

   ExamineKeyboard()
Until KeyboardReleased(#PB_Key_All)

End
; IDE Options = PureBasic 4.61 (Windows - x64)
; CursorPosition = 48
; FirstLine = 33