; setup our Screen Width and Height here for easier tracking
#ScreenWidth  = 640
#ScreenHeight = 480

; Initialize the sprite and keyboard, sound, and a 640x480, 16-bit screen
If InitSprite() = 0 Or InitKeyboard() = 0 Or InitSound() = 0 Or OpenScreen(#ScreenWidth,#ScreenHeight,16,"App Title") = 0
  MessageRequester("Error!", "Unable to Initialize Environment", #PB_MessageRequester_Ok)
  End
EndIf

ClearColor = RGB(0,0,0)

; Load in our .WAV files from the DataSection
For ExplosionSound = 0 To 4
  If CatchSound(ExplosionSound,?ExplosionSound)
    ; set the Volume 
    Volume = Random(75) + 10
    SoundVolume(ExplosionSound,Volume)
    
    ; set the pan
    Pan = Random(200)
    If Pan > 100
      Pan = 100 - Pan
    EndIf
    SoundPan(ExplosionSound,Pan)
    
    ; set the frequency (pitch)
    Frequency = Random(50000) + 10000
    SoundFrequency(ExplosionSound,Frequency)
  Else
    MessageRequester("Error!", "Unable to load sound file", #PB_MessageRequester_Ok)
    End
  EndIf
Next

; Keep going until the user hits ESCAPE
Repeat
  ; clear the screen
  ClearScreen(ClearColor)
  
  ExamineKeyboard()
  ; if the user hits the appropriate key, play the appropriate sound
  If KeyboardPushed(#PB_Key_1)
    PlaySound(0)
  EndIf
  
  If KeyboardPushed(#PB_Key_2)
    PlaySound(1)
  EndIf
  
  If KeyboardPushed(#PB_Key_3)
    PlaySound(2)
  EndIf
  
  If KeyboardPushed(#PB_Key_4)
    PlaySound(3)
  EndIf
  
  If KeyboardPushed(#PB_Key_5)
    PlaySound(4)
  EndIf
  
  ; put up text for information
  StartDrawing(ScreenOutput())
    DrawText(0,0,"Use keys 1 - 5 to play the various explosions")
    DrawText(0,400,"Press ESCAPE to quit")
  StopDrawing()
  
  FlipBuffers()
  
Until KeyboardReleased(#PB_Key_Escape)

End

DataSection
ExplosionSound:
IncludeBinary "sounds\explosion1.wav"
EndDataSection
; IDE Options = PureBasic 4.61 (Windows - x64)
; CursorPosition = 64
; FirstLine = 39