; Initialize the sprite and keyboard systems and a 640x480, 16-bit screen
If InitSprite() = 0 Or InitKeyboard() = 0 Or OpenScreen(640,480,16,"App Title") = 0
   MessageRequester("Error!", "Unable to Initialize Environment", #PB_MessageRequester_Ok)
   End
EndIf

; setup our structure
Structure Ships
           Name.s                    ; name of this ship
           LaserPower.b              ; 1-20 points per hit
           Armor.b                   ; 75-125 points depending on the ship
           ShieldPower.b             ; 50-100 points added on to Armor
           TopSpeed.b                ; 2 - 4 depending on ship type
EndStructure

; dimension our Fighters
Dim Fighter.Ships(1)

; go to the ShipNameData section
Restore ShipNameData

; use a standard array looping style
For i = 0 To 1
     ; read the data
     Read.s Fighter.Ships(i)\Name
 Next

; go to the ShipSpecsData section
Restore ShipSpecsData

; use a standard array looping style
For i = 0 To 1
    ; read the data
    Read.b Fighter.Ships(i)\LaserPower
    Read.b Fighter.Ships(i)\Armor
    Read.b Fighter.Ships(i)\ShieldPower
    Read.b Fighter.Ships(i)\TopSpeed
Next

; Set up the vertical control variable
TextY = 0

StartDrawing(ScreenOutput())
    ; Step through the Ships array and print
    For i = 0 To 1 
        shipText.s = "Ship Name: " + Fighter.Ships(i)\Name
        DrawText(0,TextY,shipText.s)
        TextY = TextY + 16

        shipText.s = "Laser Power: " + Str(Fighter.Ships(i)\LaserPower)
        DrawText(0,TextY,shipText.s)
        TextY = TextY + 16

        shipText.s = "Armor: " + Str(Fighter.Ships(i)\Armor)
        DrawText(0,TextY,shipText.s)
        TextY = TextY + 16

        shipText.s = "Shield Power: " + Str(Fighter.Ships(i)\ShieldPower)
        DrawText(0,TextY,shipText.s)
        TextY = TextY + 16
    
        shipText.s = "Top Speed: " + Str(Fighter.Ships(i)\TopSpeed)
        DrawText(0,TextY,shipText.s)
        TextY = TextY + 32
    Next

     ; display a message so the user knows how to exit     
    DrawText(0,400,"Press any key to exit")

StopDrawing()
 
FlipBuffers()  ; show the output to the user

; wait for any key to be pressed
Repeat 
   ExamineKeyboard()
Until KeyboardReleased(#PB_Key_All)

End  ; end the program

; Here is our data area
DataSection 
    ShipNameData:
        Data.s "Kliazian Raptor", "Weltic Cruiser"

    ShipSpecsData:
        Data.b 15,125,50,3
        Data.b 20,100,75,4
EndDataSection
; IDE Options = PureBasic 4.61 (Windows - x64)
; FirstLine = 45