; Initialize the sprite and keyboard systems and a 640x480, 16-bit screen
If InitSprite() = 0 Or InitKeyboard() = 0 Or OpenScreen(640,480,16,"App Title") = 0
   MessageRequester("Error!", "Unable to Initialize Environment", #PB_MessageRequester_Ok)
   End
EndIf
 
ClearColor = RGB(0,0,0) 

; setup our structure
Structure Missiles
           Speed.w             ; Missile Speed (5-20)
           MaxDistance.w       ; How far can it go (500-5000)
           CurrentDistance.w   ; How far have we gone?
EndStructure

; setup a new list for the missiles
NewList Missile.Missiles()

; set the ExitCondition to 0
ExitCondition = 0

; While the ExitCondition is 0
While ExitCondition = 0

   ClearScreen(ClearColor)          ; clear the screen to black
   
   ; Set up the vertical control variable
   TextY = 0
   
   StartDrawing(ScreenOutput())
   
        ; Step through the missile list and print info
        ForEach Missile() 
            MissileText.s = "Missile Speed: " + Str(Missile()\Speed) + ", Max Distance: " + Str(Missile()\MaxDistance) + ", Current Distance: " + Str(Missile()\CurrentDistance)
            DrawText(0,TextY,MissileText)
            TextY = TextY + 16
            
            ; now add the speed of the missile to its current distance
            Missile()\CurrentDistance = Missile()\CurrentDistance + Missile()\Speed
            ; if the distance is passed the maximum distance it can travel
            If Missile()\CurrentDistance > Missile()\MaxDistance
               ; delete the missile
               DeleteElement(Missile())
            EndIf
        Next
        
        ; display a message so the user knows how to fire/exit     
        DrawText(0,400,"Press Spacebar to Fire -- ESC to Exit")

   StopDrawing()

   ; see if any key activity has happened
   ExamineKeyboard() 

   ; to make sure that we don't just roll-up the missiles
   ; too quickly.  Make sure the player has to let go of
   ; the fire key before firing again
   If KeyboardReleased(#PB_Key_Space)
      ; if the key was released, reset our Fired flag
      Fired = 0
   EndIf

   ; If the player hits the fire key 
   If KeyboardPushed(#PB_Key_Space) And Fired = 0
     ; make sure we don't have more than 20 missiles out already
     ; Use ListSize(Missile()) for PureBasic 5 as CountList(...) is deprecated.
     ; If you have PureBasic 5.0, replace CountList(Missile()) < 19 with ListSize(Missile()) < 19
     ; If you have PureBasic 4.61, replace ListSize(Missile()) < 19 with CountList(Missile()) < 19
      If CountList(Missile()) < 19 
         ; add the element of a new missile and populate it
         If AddElement(Missile()) <> 0
            Missile()\Speed = Random(15) + 5
            Missile()\MaxDistance = Random(4500) + 500
            Missile()\CurrentDistance = 0
         Else
            MessageRequester("Error!", "Unable to allocate memory for new element", #PB_MessageRequester_Ok)
         EndIf
      EndIf
      ; set our flag to show that the missile has been fired
      ; this is so we can make sure the player releases the key
      Fired = 1
   EndIf
   
   ; if the player hits ESC, set our ExitCondition and quit
   If KeyboardPushed(#PB_Key_Escape)    
      ExitCondition = 1
   EndIf 

   FlipBuffers()  ; show the output to the user

Wend

End  ; end the program


; IDE Options = PureBasic 5.00 (Windows - x64)
; CursorPosition = 68
; FirstLine = 39
; DisableDebugger